# FaaS Characteristics and Constraints Knowledge Base (FaaSCC)
# Maintainer: Josef Spillner <josef.spillner@zhaw.ch>
#
# Implementations should read the values with the highest timestamp.
# Units: duration=s, localdisk=MB, memory=[MB], contingentload=GBs, pricecall=USD, priceload=USD
---
- name: AWS Lambda
  synonyms: Lambda, Amazon Lambda, λ
  duration:
  - 1524979005: 300 # https://aws.amazon.com/de/lambda/faqs/
  blocked:
  - 1524979005: ingress, egress:25, egress:udp, ptrace
  localdisk:
  - 1524979005: 500
  memory:
  - 1524979005: [128, 256, 512, 1024, 3008]
  parameters:
  - python:
    - 1524979005: [event, context]
  return:
  - python:
    - 1524979005: some_value
  contingentcalls:
  - 1524979005: 1000000
  contingentload:
  - 1524979005: 400000
  pricecall:
  - 1524979005: 0.0000002
  priceload:
  - 1524979005: 0.00001667
- name: Google Cloud Functions
  synonyms: GCF
  duration:
  - 1524979005: 540 # https://cloud.google.com/functions/quotas
- name: IBM Cloud Functions
  synonyms: IBM OpenWhisk
  duration:
  - 1523164605: 300
  - 1524979005: 600 # https://www.ibm.com/blogs/bluemix/2018/04/ibm-cloud-functions-doubling-time-limit-executing-actions/
- name: Microsoft Azure Functions
  synonyms: Azure Functions
  duration: # https://docs.microsoft.com/en-us/azure/azure-functions/functions-scale
  - 1502948087: 300
  - 1524979005: 600 # https://buildazure.com/2017/08/17/azure-functions-extend-execution-timeout-past-5-minutes/
